<?php

/****************************************************************\
**   PonyGallery ML 2.5.1
**   By: M. Andreas Boettcher & Benjamin Malte Meier
**   & Andreas Hartmann & The ML-Team
**   Copyright (C) 2007 - 2008 M. Andreas Boettcher
**   Based on: PonyGallery 1.1.5  by Danial Taherzadeh
**   Released under GNU GPL Public License
**   License: http://www.gnu.org/copyleft/gpl.html or have a look
**   at administrator/components/com_ponygallery/LICENSE.txt
\****************************************************************/

  #### Original Copyright #########################
  ##   PonyGallery 1.1.5                         ##
  ##   By: Danial Taherzadeh                     ##
  ##   http://www.taher-zadeh.com                ##
  ##   Based on : Akogallery 2.1 by Arthur Konze ##
  ##   Released Under GNU GPL Public License     ##
  #################################################

function fixfilename($orig,$replace_extension=0) {
  global $ag_filenamesearch, $ag_filenamereplace, $extension; //<= Fr was $extension als global?

  $orig = strtolower(basename($orig));
  // replace special chars
  if(!empty($ag_filenamesearch)) {
    $filenamesearch  = explode("|",$ag_filenamesearch);
  } else {
    $filenamesearch = array();
  }

  if(!empty($ag_filenamereplace)) {
    $filenamereplace = explode("|",$ag_filenamereplace);
  } else {
    $filenamereplace = array();
  }

  // replace whitespace with underscore
  array_push($filenamesearch,"\s");
  array_push($filenamereplace,"_");
  // replace other stuff
  array_push($filenamesearch,"[^a-z_0-9-]");
  array_push($filenamereplace,"");

  //checks for different array-length
  $lengthsearch  = sizeof($filenamesearch);
  $lengthreplace = sizeof($filenamereplace);
  if($lengthsearch>$lengthreplace) {
    while($lengthsearch>$lengthreplace) {
    array_push($filenamereplace,"");
    $lengthreplace = $lengthreplace+1;
    }
  } elseif($lengthreplace>$lengthsearch) {
    while($lengthreplace>$lengthsearch) {
      array_push($filenamesearch,"");
      $lengthsearch = $lengthsearch+1;
    }
  }

  //checks for extension
  $extensions = array('.jpeg','.jpg','.jpe','.gif','.png');
  for($i=0;$i<sizeof($extensions);$i++) {
    $extensiontrue = substr_count($orig,$extensions[$i]);
    if($extensiontrue !=0) {
      $extension=true;
    }
  }
  //replaces extension if present
  if($extension) {
    $fileextension = ereg_replace('.*\.([^\.]*)$', '\\1', $orig);
    $fileextensionlength = strlen($fileextension);
    $filenamelength = strlen($orig);
    $filename = substr($orig,-$filenamelength,-$fileextensionlength-1);
   //no extension found (Batchupload)
  } else {
    $filename = $orig;
  }
  for ($i=0;$i<$lengthreplace;$i++) {
    $searchstring = "!".$filenamesearch[$i]."+!i";
    $filename = preg_replace($searchstring, $filenamereplace[$i] ,$filename);
  }
  if($extension && $replace_extension==0) {
    //returns filename with extension for regular upload
    return $filename.".".$fileextension;
  } else {
    //returns filename without extension for batchupload
    return $filename;
  }
}


function copyFile($srcFile, $destPath, $destName) {

  $srcFileCopy = $destPath . '/' . $destName;
  if (copy($srcFile, $srcFileCopy)) {
    return true;
  } else {
    return false;
  }
}


function copyOriginal($srcFile, $destName) {
  global $ag_pathoriginalimages, $mosConfig_absolute_path;

if ( move_uploaded_file($srcFile, $mosConfig_absolute_path . $ag_pathoriginalimages .'/'. $destName) ) {
return true;
} else {
return false;
}
}


function removeOrigFile($srcFilename) {
  global $ag_pathoriginalimages, $mosConfig_absolute_path;

  if ( removeFile($srcFilename, $mosConfig_absolute_path . $ag_pathoriginalimages) ) {
    return true;
  } else {
    return false;
  }
}


function removeFile($srcFilename, $srcFilePath) {

  $removeFilename = $srcFilePath . '/' . $srcFilename;
  if ( unlink($removeFilename) ) {
    return true;
  } else {
    return false;
  }
}

function resize_image($src_file, $dest_file, $useforresizedirection, $new_width, $thumbheight, $method, $dest_qual, $max_width=false) {
  // Doing resize instead of thumbnail, copy original and remove it.
$imagetype = array( 1 => 'GIF', 2 => 'JPG', 3 => 'PNG', 4 => 'SWF', 5 => 'PSD', 6 => 'BMP', 7 => 'TIFF', 8 => 'TIFF', 9 => 'JPC', 10 => 'JP2', 11 => 'JPX', 12 => 'JB2', 13 => 'SWC', 14 => 'IFF');
$imginfo = getimagesize($src_file);

if ($imginfo == null)
  die(_PONYGALLERY_FOUR_ERR);
  $imginfo[2] = $imagetype[$imginfo[2]];
  // GD can only handle JPG & PNG images
  if ($imginfo[2] != 'JPG' && $imginfo[2] != 'PNG' && $imginfo[2] != 'GIF' && ($method == 'gd1' || $method == 'gd2')) die(_PONYGALLERY_GD_ONLY);
    // height/width
    $srcWidth = $imginfo[0];
    $srcHeight = $imginfo[1];
  if ($max_width) {
    echo _PONYGALLERY_REZ_MAX . "<br />";
    $ratio = max($srcHeight,$srcWidth) / $new_width ;
    //$ratio = $srcWidth / $new_width;
  } else {
    echo _PONYGALLERY_CREAT_THBN_FROM . " $imginfo[2], $imginfo[0] x $imginfo[1]...<br />";
    //Wird durchlaufen, wenn nach Weite konvertiert wird
    if ($useforresizedirection) {
      $ratio = ($srcWidth / $new_width);
      $testheight = ($srcHeight/$ratio);
      //Wird durchlaufen, wenn die neue Hhe die angegebene Maximalhhe berschreitet
      if($testheight>$thumbheight) {
        $ratio = ($srcHeight/$thumbheight);
      }
    //Wird durchlaufen, wenn nach Breite konvertiert wird
    } else {
      $ratio = ($srcHeight / $thumbheight);
      $testwidth = ($srcWidth/$ratio);
      //Wird durchlaufen, wenn die neue Breite die angegebene Maximalbreite berschreitet
      if($testwidth>$new_width) {
        $ratio = ($srcWidth/$new_width);
      }
    }
  }
  $ratio = max($ratio, 1.0);

  $destWidth = (int)($srcWidth / $ratio);
  $destHeight = (int)($srcHeight / $ratio);
  /* Debug
  if ($max_width) {
  echo "Source: $src_file<br />";
  echo "Dest: $dest_file<br />";
  echo "Width: $destWidth<br />";
  echo "Height: $destHeight<br />";
  die('Hmmm.');
  } */
  // Method for thumbnails creation
  switch ($method) {
    case 'gd1' :
      if ( !function_exists('imagecreatefromjpeg' )) {
        die(_PONYGALLERY_GDIMAGE_NOT);
      }
      if ( $imginfo[2] == 'JPG' ) {
        $src_img = imagecreatefromjpeg($src_file);
      } elseif ( $imginfo[2] == 'PNG' ) {
        $src_img = imagecreatefrompng($src_file);
      } else {
        $src_img = imagecreatefromgif($src_file);
      }
      if ( !$src_img ) {
        $ERROR = $lang_errors['invalid_image'];
        return false;
      }
      $dst_img = imagecreate($destWidth, $destHeight);
      imagecopyresized($dst_img, $src_img, 0, 0, 0, 0, $destWidth, (int)$destHeight, $srcWidth, $srcHeight);
      imagejpeg($dst_img, $dest_file, $dest_qual);
      imagedestroy($src_img);
      imagedestroy($dst_img);
    break;

    case 'gd2' :
      if ( !function_exists('imagecreatefromjpeg') ) {
        die(_PONYGALLERY_GDIMAGE_NOT);
      }
      if ( !function_exists('imagecreatetruecolor') ) {
        die(_PONYGALLERY_GD2IMAGE);
      }
      if ( $imginfo[2] == 'JPG' ) {
        $src_img = imagecreatefromjpeg($src_file);
      } elseif ($imginfo[2] == 'PNG'){
        $src_img = imagecreatefrompng($src_file);
      } else {
        $src_img = imagecreatefromgif($src_file);
      }

      if ( !$src_img ){
        $ERROR = $lang_errors['invalid_image'];
        return false;
      }
      $dst_img = imagecreatetruecolor($destWidth, $destHeight);
      imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $destWidth, (int)$destHeight, $srcWidth, $srcHeight);
      imagejpeg($dst_img, $dest_file, $dest_qual);
      imagedestroy($src_img);
      imagedestroy($dst_img);
    break;
  }

  // Set mode of uploaded picture
  chmod($dest_file, octdec('644'));

  // We check that the image is valid
  $imginfo = getimagesize($dest_file);
  if ( $imginfo == null ) {
    return false;
  } else {
    return true;
  }
}


function recursive_listdir( $base ) {
  static $filelist = array();
  static $dirlist = array();

  if(is_dir($base)) {
    $dh = opendir($base);
    while (false !== ($dir = readdir($dh))) {
      if (is_dir($base .'/'. $dir) && $dir !== '.' && $dir !== '..' && strtolower($dir) !== 'cvs' && strtolower($dir) !== '.svn') {
        $subbase = $base .'/'. $dir;
        $dirlist[] = $subbase;
        $subdirlist = recursive_listdir($subbase);
      }
    }
    closedir($dh);
  }
  return $dirlist;
}


function bb_decode($text) {
  $text = nl2br($text);
  static $bbcode_tpl = array();
  static $patterns = array();
  static $replacements = array();
  // First: If there isn't a "[" and a "]" in the message, don't bother.
  if ((strpos($text, '[') === false || strpos($text, ']') === false)) {
    return $text;
  }
  // [b] and [/b] for bolding text.
  $text=str_replace( "[b]", '<b>', $text );
  $text=str_replace( "[/b]", '</b>', $text );

  // [u] and [/u] for underlining text.
  $text=str_replace( "[u]", '<u>', $text );
  $text=str_replace( "[/u]", '</u>', $text );

  // [i] and [/i] for italicizing text.
  $text=str_replace( "[i]", '<i>', $text );
  $text=str_replace( "[/i]", '</i>', $text );

  if (!count($bbcode_tpl )) {
    // We do URLs in several different ways..
    $bbcode_tpl['url']='<span class="bblink"><a href="{URL}" target="_blank">{DESCRIPTION}</a></span>';
    $bbcode_tpl['email']='<span class="bblink"><a href="mailto:{EMAIL}">{EMAIL}</a></span>';
    $bbcode_tpl['url1']=str_replace( '{URL}', '\\1\\2', $bbcode_tpl['url'] );
    $bbcode_tpl['url1']=str_replace( '{DESCRIPTION}', '\\1\\2', $bbcode_tpl['url1'] );
    $bbcode_tpl['url2']=str_replace( '{URL}', 'http://\\1', $bbcode_tpl['url'] );
    $bbcode_tpl['url2']=str_replace( '{DESCRIPTION}', '\\1', $bbcode_tpl['url2'] );
    $bbcode_tpl['url3']=str_replace( '{URL}', '\\1\\2', $bbcode_tpl['url'] );
    $bbcode_tpl['url3']=str_replace( '{DESCRIPTION}', '\\3', $bbcode_tpl['url3'] );
    $bbcode_tpl['url4']=str_replace( '{URL}', 'http://\\1', $bbcode_tpl['url'] );
    $bbcode_tpl['url4']=str_replace( '{DESCRIPTION}', '\\2', $bbcode_tpl['url4'] );
    $bbcode_tpl['email']=str_replace( '{EMAIL}', '\\1', $bbcode_tpl['email'] );
    // [url]xxxx://www.phpbb.com[/url] code..
    $patterns[1] = '#\[url\]([a-z]+?://){1}([a-z0-9\-\.,\?!%\*_\#:;~\\&$@\/=\+\(\)]+)\[/url\]#si';
    $replacements[1] = $bbcode_tpl['url1'];
    // [url]www.phpbb.com[/url] code.. (no xxxx:// prefix).
    $patterns[2] = '#\[url\]([a-z0-9\-\.,\?!%\*_\#:;~\\&$@\/=\+\(\)]+)\[/url\]#si';
    $replacements[2] = $bbcode_tpl['url2'];
    // [url=xxxx://www.phpbb.com]phpBB[/url] code..
    $patterns[3] = '#\[url=([a-z]+?://){1}([a-z0-9\-\.,\?!%\*_\#:;~\\&$@\/=\+\(\)]+)\](.*?)\[/url\]#si';
    $replacements[3] = $bbcode_tpl['url3'];
    // [url=www.phpbb.com]phpBB[/url] code.. (no xxxx:// prefix).
    $patterns[4] = '#\[url=([a-z0-9\-\.,\?!%\*_\#:;~\\&$@\/=\+\(\)]+)\](.*?)\[/url\]#si';
    $replacements[4] = $bbcode_tpl['url4'];
    //[email]user@domain.tld[/email] code..
    $patterns[5] = '#\[email\]([a-z0-9\-_.]+?@[\w\-]+\.([\w\-\.]+\.)?[\w]+)\[/email\]#si';
    $replacements[5] = $bbcode_tpl['email'];
  }
  $text=preg_replace($patterns, $replacements, $text);
  return $text;
}


function fixuserentrie($text) {
  global $database;

  $text = trim($text);
  if($text != "") {
    $text = strip_tags($text);
    $text = $database->getEscaped($text);
  }
  return $text;
}


function fixuserentrie2($text) {
  global $database;

  $text = trim($text);
  if($text != "") {
    $text = strip_tags($text);
    $text = htmlentities($text, ENT_QUOTES);
    $text = $database->getEscaped($text);
  }
  return $text;
}


function fixadminentrie($text) {
  global $database;

  $text = trim($text);
  return $text;
}


function ShowCategoryPath( $cat, $access=0 ) {
  global $database, $my;

  $cat=intval($cat);
  $parent_id = 1000;

  while ($parent_id) {
    // read name and parent_id
    $query = "SELECT name, parent 
        FROM #__ponygallery_catg 
        WHERE cid=$cat AND access<='$my->gid'";
    $database->setQuery( $query );
    $database->loadObject( $row );
    if (isset($row->parent)) {
      $parent_id = $row->parent;
      $name = $row->name;
    } else {
      $parent_id = '';
      $name = '';
    }
    // write path
    if (empty($path)) {
      $path = $name;
    } else {
      $path = $name . ' &raquo; ' . $path;
    }
    // next looping
    $cat = $parent_id;
  }
  return $path . ' ';
}


function ShowDropDownCategoryList($cat, $cname = 'cat', $extra = null, $orig=null) {
  global $database, $my, $func, $ag_cats_access, $ag_category;

  $ignore = array();
  $allowedcats = explode(',', $ag_category);

  $output = "<select name=\"$cname\" class=\"inputbox\" $extra >\n";
  $output .= "<option value=\"0\"></option>";
  $query = "SELECT cid, parent
    FROM #__ponygallery_catg";
  //if($ag_cats_access==0 && !isPonyMod()) {
   $query .= " WHERE access<='".$my->gid."'";
  //}
  $query .= " ORDER BY parent, name ASC";
  $database->setQuery($query);
  $rows = $database->loadObjectList();

  foreach($rows as $row) {
    if(($row->parent==0 || $row->parent=="") && !in_array($row->cid,$ignore)) {
      $ignore[] = $row->cid;
      if($row->cid!=$orig) {
        if( ($func!="showupload" && $func!="editpic") || in_array($row->cid,$allowedcats ) ) {
          $output .="    <option value=\"".$row->cid."\"";
          if($cat==$row->cid) {
            $output .= "selected";
          }
          $output .=">".ShowCategoryPath($row->cid)."</option>\n";
        }
        $output .= catg_sub($row->cid,1,$rows,$ignore,$orig,$cat,$allowedcats);
      }
    }
  }
  $output .= "</select>\n";
  return $output;
}


function catg_sub($id,$ebene,$rows,$ignore,$orig,$cat,$allowedcats) {
  global $func;
  $output = "";
  foreach($rows as $row) {
    if(!in_array($row->cid,$ignore) && $row->parent!=0 && $row->parent!="") {
      if($row->parent==$id) {
        $ignore[] = $row->cid;
        if($row->cid!=$orig) {
          if( ($func!="showupload" && $func!="editpic") || in_array($row->cid,$allowedcats ) ) {
            $output .="    <option value=\"".$row->cid."\"";
            if($cat==$row->cid) {
              $output .= " selected";
            }
            $output .=">".ShowCategoryPath($row->cid)."</option>\n";
          }
          $ebeneneu = $ebene+1;
          $output .= catg_sub($row->cid,$ebeneneu,$rows,$ignore,$orig,$cat,$allowedcats);
        }
      }
    }
  }
  return $output;
}


function processtext($text,$nr=40) {
  $mytext=explode(" ",trim($text));
  $newtext=array();
  foreach($mytext as $k=>$txt)
  {
      if (strlen($txt)>$nr)
      {
          $txt=wordwrap($txt, $nr, "- ", 1);
      }
      $newtext[]=$txt;
  }
  return implode(" ",$newtext);
}


/** 
* Funktion, die aus der Upload-Time eines Bildes und einer festgelegten Zeitspanne
* ermittelt, ob ein Bild als NEW gekennzeichnet werden soll
* 
* @param    integer    $uptime: Upload-Datum in Sekunden
* @param    integer    $daysnew: Zeitspanne der Markierung in Tagen
* @return   string.....$isnew: enthlt entweder den Pfad zum New-Image oder nichts
* */
function CheckNew($uptime, $daysnew) {

  // Gibt die seit Beginn der Unix-Epoche (Januar 1 1970 00:00:00 GMT) bis jetzt 
  // vergangene Zeitspanne in Sekunden zurck.
  $thistime   = time();
  // Errechnet die Anzahl Sekunden fr die unter $ag_daysnew angegebenen Tage 
  // (siehe Configuration Manager)
  $timefornew = 43200*$daysnew;
  // Wenn die Zeitspanne seit dem Upload kleiner ist, als die Zeitspanne, die unter 
  // $ag_daysnew angegeben ist...
  if (($thistime - $uptime) < $timefornew) { 
    // ...wird das kleine Image "New" angezeigt ...
    $isnew = "&nbsp;<img src=\"components/com_ponygallery/images/new.png\" border=\"0\" alt=\"\" />"; 
  // ...ansonsten ...
  } else {
    // wird nichts ausgegeben
    $isnew = "";
  }
  // Rckgabewert der Funktion
  return $isnew;
}

/** 
* Prfung der Bilder einer Kategorie und ggf. vorhandener Unterkategorien usw.
* Aufruf der Funktion CheckNew(), um festzustellen, ob NEW zutrifft
* rekursiver Aufruf -> vorzeitig beenden, wenn 'new' festgestellt wurde
* 
* @param    integer    $catids_values: eine bzw. mehrere ID der Kategorie/Unterkategorien
* @return   string.....$isnew: enthlt entweder den Pfad zum New-Image oder nichts
* */
function CheckNewCatg($catids_values) {
  global $ag_catdaysnew,$database,$my;

  $isnewcat = "";
  //Abfrage der Kategorie = $cid
  $database->setQuery( "SELECT MAX(imgdate) 
      FROM #__ponygallery AS a  
      LEFT JOIN #__ponygallery_catg AS c ON c.cid=a.catid 
      WHERE a.catid in ($catids_values)
      AND a.published = '1' AND a.approved='1' AND c.access <= $my->gid AND c.published = '1'"); 
  $maxdate = $database->loadResult();
  if ($database->getErrorNum()) {
    echo $database->stderr(true);
  }
  
  //wenn maxdate = NULL, ist kein Bild gefunden worden
  //sonst Prfung des Datums auf 'new'
  if ( $maxdate != NULL ) {
    $isnewcat = CheckNew($maxdate, $ag_catdaysnew); 
    if ( $isnewcat != "" ) return $isnewcat;
  }

  //In der Kategorie wurde kein Bild bzw. kein Bild mit 'new' gefunden
  //Abfrage der untergeordneten Kategorien mit parent = $cid
  $database->setQuery( "SELECT cid 
      FROM #__ponygallery_catg 
      WHERE parent in ($catids_values)
      AND access <= $my->gid AND published = '1' " ); 

  //Wenn Rckgabe von 0 Zeilen existieren keine zutreffenden Unterkategorien 
  //Rckgabe von ""
  $catids = $database->loadResultArray();
  if ($database->getErrorNum()) {
    echo $database->stderr(true);
  }
  
  if (count($catids) == 0) {
    return "";
  }
  //Array aufspliten in kommaseparierten String
  $catids_values = implode (",",$catids);

  //erneuter Funktionsaufruf mit Prfung
  //auf 'new' Bilder und Unterkategorien
  //wenn Rckgabe != "" -> vorzeitiges Ende der Suche
  $isnewcat = CheckNewCatg($catids_values);

  // nach erfolgloser Suche
  // Rckgabewert leer
  return $isnewcat;
}
?>
