<?php

/****************************************************************\
**   PonyGallery ML 2.5.1
**   By: M. Andreas Boettcher & Benjamin Malte Meier
**   & Andreas Hartmann & The ML-Team
**   Copyright (C) 2007 - 2008 M. Andreas Boettcher
**   Released under GNU GPL Public License
**   License: http://www.gnu.org/copyleft/gpl.html or have a look
**   at administrator/components/com_ponygallery/LICENSE.txt
\****************************************************************/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class ponymodule {
  var $_config    = array();
  var $_stag      = null;
  var $_cmtcount  = "";

  function setConfig($config) {
    $this->_config = $config;
  }

  function addconfig($key, $value="") {
    $this->_config[$key] = $value;
  }

  function addshorttag($tag) {
    $this->_stag = $tag;
  }

  function cmttest($only_comments="") {
    if($only_comments=="") {
      if( $this->_config['sorting']=="cmtcount ASC"
       || $this->_config['sorting']=="cmtcount DESC"
       || $this->_config['sorting']=="co.cmtdate ASC"
       || $this->_config['sorting']=="co.cmtdate DESC"
       || $this->_config['showcmtdate']==1
       || $this->_config['showcmttext']==1
       || $this->_config['showcmtcount']==1) {
         return true;
      } else {
        return false;
      }
    } else if( $this->_config['sorting']=="co.cmtdate ASC"
     || $this->_config['sorting']=="commentrand"
     || $this->_config['sorting']=="co.cmtdate DESC") {
      return true;
    } else {
      return false;
    }
  }


  function dynctest($cid=0) {
    global $my, $database;

    if($this->_config['dynamiccats']==1) {
      if($this->_config['option'] == "com_ponygallery" && $this->_config['func']=="viewcategory" && $this->_config['catid']!=0 && $this->_config['catid']!="") {
        if($cid==1) {
          return $this->_config['catid'];
        } else {
          return true;
        }
      } elseif($this->_config['option'] == "com_ponygallery" && $this->_config['func']=="detail" && $this->_config['imgid']!=0 && $this->_config['imgid']!="") {
        if($cid==1) {
          $query  = "SELECT p.catid FROM #__ponygallery as p"
                   ." LEFT JOIN #__ponygallery_catg as c ON c.cid=p.catid"
                   . " WHERE c.published='1' AND c.access<=".$my->gid
                   ." AND p.published='1' AND p.approved='1' AND p.id = ".$this->_config['imgid']
                   ." LIMIT 1";
          $database->setQuery( $query );
          return $database->loadResult();
        } else {
          return true;
        }
      }
    } else {
      return false;
    }
  }


  function getPonyId($Itemid_modul="") {
	global $database;
    $Itemid_param = intval( mosGetParam( $_REQUEST, 'Itemid', '' ) );
    if(trim( mosGetParam( $_REQUEST, 'option', "" ) ) == "com_ponygallery" && $Itemid_param!="" && $Itemid_param !=0 && $Itemid_param != 99999 ) {
      return "&amp;Itemid=".$Itemid_param;
    } elseif($Itemid_modul!='') {
      return "&amp;Itemid=".$Itemid_modul;
    } else {
      $database->setQuery("SELECT id FROM #__menu WHERE link LIKE '%com_ponygallery%' AND (published='1' OR published='0') AND access='0' ORDER BY id DESC Limit 1");
  $Itemid_pg = $database->loadResult();
      if ($Itemid_pg=='' || $Itemid_pg==NULL) {
        $database->setQuery("SELECT id FROM #__menu WHERE link LIKE '%com_ponygallery%' AND (published='1' OR published='0') AND access='1' ORDER BY id DESC Limit 1");
      $Itemid_pg = $database->loadResult();
    }
	$Itemid_pg = ($Itemid_pg=="" || $Itemid_pg==NULL) ? "" : "&amp;Itemid=".$Itemid_pg;
     return $Itemid_pg;
    }
  }

  function getCatgLink($cid) {
    return sefRelToAbs("index.php?option=com_ponygallery".$this->getPonyId()."&amp;func=viewcategory&amp;catid=".$cid);
  }

  function dbImages($sorting,$limit="",$cmt="") {
  global $my, $database;
    $query  = "SELECT p.id as picid, p.catid, p.imgthumbname, p.imgfilename, p.imgdate\n"
              .", p.imgtitle, p.imgtext, p.imgcounter, p.imgvotes\n"
              .", (p.imgvotesum/p.imgvotes) AS vote, c.name AS cattitle\n";
    if($this->cmttest()){
      $query .= ", count(co.cmtid) AS cmtcount, co.cmttext, co.cmtdate, co.cmtname, co.cmtid as commentid\n";
    }
    $query .= "\n FROM #__ponygallery as p\n"
             ." INNER JOIN #__ponygallery_catg as c ON c.cid=p.catid\n";
    if($this->cmttest()){
      $query .= " INNER JOIN #__ponygallery_comments as co ON co.cmtpic=p.id\n";
    }
    $query .= " WHERE c.published='1' AND c.access<=".$my->gid."\n"
             ." AND p.published='1' AND p.approved='1'\n";
    if($this->cmttest() && $cmt != "") {
    	 $query .= " AND co.cmtpic IN (".$cmt.")\n";
    }
    if($this->dynctest()){
      $query .= " AND p.catid = ".$this->dynctest(1)."\n";
    }
    if($this->_config['cats'] != "") {
    	 $query .= " AND p.catid";
    	 $query .= ($this->_config['showorhidecats']==1) ? " IN" : " NOT IN";
    	 $query .= " (".$this->_config['cats'].")\n";
    }
    if($this->cmttest()){
      $query .= " AND co.published='1' AND co.approved='1'\n"
               ." GROUP BY co.cmtpic\n";
    }
    $query .= " ORDER BY ".$sorting."\n";
    if($limit != "") {
      $query .= " LIMIT ".$limit;
    }
    $database->setQuery( $query );
    return $database->loadObjectList();
   }

  function dbComments($sorting,$limit="",$img="",$count="") {
  global $my, $database;
    if($count=="") {
      $query  = "SELECT co.cmttext, co.cmtdate, co.cmtname, co.cmtid as commentid, p.id as picid, p.catid\n"
               .", p.imgthumbname, p.imgfilename, p.imgdate, p.imgtitle, p.imgtext, p.imgcounter, p.imgvotes\n"
               .", (p.imgvotesum/p.imgvotes) AS vote, c.name AS cattitle\n";
    } else {
      $query  = "SELECT co.cmtpic AS id, count(co.cmtid) AS cmtcount\n";
    }
            
    $query .= " FROM #__ponygallery_comments as co\n"
             ." INNER JOIN #__ponygallery as p ON co.cmtpic=p.id\n"
             ." INNER JOIN #__ponygallery_catg as c ON c.cid=p.catid\n"
             ." WHERE c.published='1' AND c.access<=".$my->gid
             ." AND p.published='1' AND p.approved='1'";
    if($img != "") {
    	 $query .= " AND p.id IN (".$img.")";
    }
    if($this->dynctest()){
      $query .= " AND p.catid = ".$this->dynctest(1);
    }
    if($this->_config['cats'] != "") {
    	 $query .= " AND p.catid";
    	 $query .= ($this->_config['showorhidecats']==1) ? " IN" : " NOT IN";
    	 $query .= " (".$this->_config['cats'].")";
    }
    $query .= " AND co.published='1' AND co.approved='1'\n";
    if($count==1) {
      $query .= " GROUP BY co.cmtpic\n";
    }
    $query .= " ORDER BY ".$sorting."\n";
    if($limit != "" && $count=="") {
      $query .= " LIMIT ".$limit;
    }
    $database->setQuery( $query );
    $objects = $database->loadObjectList();
    if($this->_config['showcmtcount'] == 1 && $this->_config['detailpic_open']==0 && $count=="") {
     $cmtobj = $this->dbComments($sorting,"",$img,1);
     $this->_cmtcount = array();
     foreach($cmtobj as $obj) {
       $this->_cmtcount[$obj->id] = $obj->cmtcount;
     }
    }
    return $objects;
  }


  function showtext($obj,$tdclass) {
    global $my, $database;

    if($this->_config["showtext"]==1) {
      $output = "   <td".$tdclass.">\n";
      if($this->_config['showtitle'] == 1) {
        if($this->_config['piclink']==1) {
          $link = $this->getCatgLink($obj->catid);
        } else {
          if ( ( $this->_config['showdetailpage']==0 && $my->gid!=0 ) || $this->_config['showdetailpage']==1 ) {
            $link = openimage($this->_config['detailpic_open'], $obj->picid, $obj->imgfilename, $obj->imgtitle, $obj->imgtext);
            $link = str_replace("&amp;Itemid=&amp;Itemid=","&amp;Itemid=",$link);
            if($this->_config['detailpic_open']==0) {
              $link .= "#ponyimg";
            }
          } else {
            $link = "javascript:alert('"._PONYGALLERY_NO_DETAILS_ALERT."')";
          }
		    $link = str_replace("lightbox[ponygallery]","lightbox[".$this->_stag."2]",$link);
		    $link = str_replace("rel=\"ponygallery\"","rel=\"".$this->_stag."2\"",$link);
		  }
        $output .="    <a href=\"".$link;
        $output .="\" class=\"".$this->_stag."name\">\n          ".$obj->imgtitle ."\n        </a><br />\n";
      }
      if($this->_config['showcatg'] == 1) {
        $output .= "          "._PONYGALLERY_CATEGORY.":\n"
                ."        <a href=\"".$this->getCatgLink($obj->catid)."\" class=\"".$this->_stag."cat\" title=\"".$obj->cattitle."\">\n"
                ."          ".$obj->cattitle."\n        </a><br />\n";
      }
      if($this->_config['showdescription'] == 1 && $obj->imgtext !='') {
        $output .= "          <span class=\"".$this->_stag."description\">"._PONYGALLERY_DESCRIPTION.": ".$this->decodetext($obj->imgtext,$this->_config['strdescount'])."</span><br />\n";
      }
      if($this->_config['showimgdate'] == 1) {
        $output .= "        <span class=\"".$this->_stag."imgdate\">"._PONYGALLERY_UPLOAD_DATE.":<br /> "
                . strftime( $this->_config['dateformat'], $obj->imgdate )."</span><br />\n";
      }
      if($this->_config['showhits'] == 1) {
        $output .= "        <span class=\"".$this->_stag."hits\">"._PONYGALLERY_HITS.": ".$obj->imgcounter."</span><br />\n";
      }
      if($this->_config['showvotesum'] == 1) {
        $output .= "        <span class=\"".$this->_stag."votes\">"._PONYGALLERY_RATING.": ";
        if($obj->vote=="") {
          $output .= _PONYGALLERY_NO_RATE;
        } else {
          $output .= number_format( $obj->vote, 2, ",", "." );
          if($this->_config['showvotes'] == 1) {
            $output .= " (".$obj->imgvotes.")";
          }
        }
        $output .= "<br /></span>\n";
      }
      if($this->_config['showcmtcount'] == 1 && $this->cmttest() && $this->_config['detailpic_open']==0) {
        if(isset($obj->cmtcount)) {
          $count = $obj->cmtcount;
        } else if(count($this->_cmtcount)>0) {
          $count = $this->_cmtcount[$obj->picid];
        } else {
          $count = 0;
        }        
        /*if($count==0) {
                $output .= "        <a href=\"".sefRelToAbs($this->_config['link'].$obj->picid."#ponycomments")."\" class=\"".$this->_stag."cmtcount_no\">"._PONYGALLERY_NO_VOTES." "._PONYGALLERY_COMMENT."</a><br />\n";
        } else if($count==1) {
                $output .= "        <a href=\"".sefRelToAbs($this->_config['link'].$obj->picid."#ponycomments")."\" class=\"".$this->_stag."cmtcount_one\">".$obj->cmtcount." "._PONYGALLERY_COMMENT."</a><br />\n";
        } else {
                $output .= "        <a href=\"".sefRelToAbs($this->_config['link'].$obj->picid."#ponycomments")."\" class=\"".$this->_stag."cmtcount_more\">".$count." "._PONYGALLERY_COMMENT."</a><br />\n";
        }*/
        $output .= "        <a href=\"".sefRelToAbs($this->_config['link'].$obj->picid."#ponycomments")."\" class=\"".$this->_stag."cmtcount\">"._PONYGALLERY_COMMENTS_COUNT.": ".$count."</a><br />\n";
      }
      if($this->_config['showcmtdate'] == 1) {
        $output .= "        <span class=\"".$this->_stag."cmtdate\">"._PONYGALLERY_LAST_COMMENT_DATE.": <br />"
                  . strftime( $this->_config['dateformat'], $obj->cmtdate )."</span><br />\n";
      }
      if($this->_config['showcmttext'] == 1) {
          $user=$obj->cmtname;
          $query = "SELECT id 
              FROM #__users 
              WHERE `username` = '$user'";
          $database->setQuery($query);
          $result = $database->loadResult();
        if ($this->_config['combuild'] == 1 && $result!='') {
          $output .= "        <span class=\"".$this->_stag."cmttext\">"._PONYGALLERY_LAST_COMMENT_BY."\n        <a href=\"".sefRelToAbs("index.php?option=com_comprofiler&amp;task=userProfile&amp;user=".$result)."\">\n          ".$obj->cmtname."\n        </a>";
        } else {
          $output .= "        <span class=\"".$this->_stag."cmttext\">"._PONYGALLERY_LAST_COMMENT_BY.$obj->cmtname;
        }
        $output .= ":<br />\n        &quot; ".$this->decodetext($obj->cmttext,$this->_config['strcmtcount']);
        if ($this->_config['showcmtmore'] == 1 && $this->_config['strcmtcount']>0) {
          $output .= " <a href=\"".sefRelToAbs($this->_config['link'].$obj->picid."#ponycomments")."\">\n          "._READ_MORE."</a>\n";
        }
        $output .= " &quot;\n        </span>\n";
      }
      $output .= "      </td>\n";
    } else {
      $output = "";
    }
    return $output;
  }


  function showimage($obj,$tdclass) {
    global $my;

    $output ="   <td".$tdclass.">\n";

    if( $obj->picid != "" ) {
     $thmsize = getimagesize($this->_config['thumbnailabspath'].$obj->imgthumbname);
     $thmWidth = $thmsize[0];
     $thmHeight = $thmsize[1];
     // if photos are resized by width
    if ($this->_config['useforresizedirection']==1) {
     $ratio = ($thmWidth / $this->_config['imgwidth']);
     $testheight = ($thmHeight/$ratio);
     // if thumbheight is higher than maxheight
      if($testheight>$this->_config['imgheight']) {
        $ratio = ($thmHeight / $this->_config['imgwidth']);
      }
     // if photos are resized by height
      } else {
        $ratio = ($thmHeight / $this->_config['imgheight']);
        $testwidth = ($thmWidth/$ratio);
        // if thumbwidth is larger than maxwidth
        if($testwidth>$this->_config['imgwidth']) {
          $ratio = ($thmWidth/$this->_config['imgheight']);
        }
      }
     // Checks if image has to be resized  
     $ratio = max($ratio, 1.0);
     $destWidth = (int)($thmWidth / $ratio);
     $destHeight = (int)($thmHeight / $ratio);
     if($this->_config['piclink']==1) {
       $link = $this->getCatgLink($obj->catid);
     } else {
       if ( ( $this->_config['showdetailpage']==0 && $my->gid!=0 ) || $this->_config['showdetailpage']==1 ) {
         $link = openimage($this->_config['detailpic_open'], $obj->picid, $obj->imgfilename, $obj->imgtitle, $obj->imgtext);
         $link = str_replace("&amp;Itemid=&amp;Itemid=","&amp;Itemid=",$link);
       } else {
         $link = "javascript:alert('"._PONYGALLERY_NO_DETAILS_ALERT."')";
       }
       if($this->_config['detailpic_open']==0) {
         $link .= "#ponyimg";
       }
       $link = str_replace("lightbox[ponygallery]","lightbox[".$this->_stag."1]",$link);
       $link = str_replace("rel=\"ponygallery\"","rel=\"".$this->_stag."1\"",$link);
     }

     $output .= "    <a href=\"".$link."\">\n";
     $output .= "     <img src=\"".$this->_config['thumbnailpath'] . $obj->imgthumbname."\" alt=\"".$obj->imgtitle."\" width=\"".$destWidth."\" height=\"".$destHeight."\" class=\"";
     $output .= ($this->_config['ponystyle']==1) ? $this->_config['myborder'] : "".$this->_stag."img" ;
     $output .= "\" />\n";
     $output .= "    </a>\n";
    } else {
      $output .= "    &nbsp;\n";
    }
    $output .= "   </td>\n";
    return $output;
  }


  function decodetext($text,$length=0) {
    global $mosConfig_live_site;

    $text = trim($text);
    $length = ($length!=0) ? $length-1 : 0;

    //Smilies if smilies are supportet
    $smiley = array();
    $smiley[':smile:']          = "sm_smile.gif";
    $smiley[':cool:']           = "sm_cool.gif";
    $smiley[':grin:']           = "sm_biggrin.gif";
    $smiley[':wink:']           = "sm_wink.gif";
    $smiley[':none:']           = "sm_none.gif";
    $smiley[':mad:']            = "sm_mad.gif";
    $smiley[':sad:']            = "sm_sad.gif";
    $smiley[':dead:']           = "sm_dead.gif";

    if ( $this->_config['anismilie'] ) {
        $smiley[':yes:']            = "sm_yes.gif";
        $smiley[':lol:']            = "sm_laugh.gif";
        $smiley[':smilewinkgrin:']  = "sm_smilewinkgrin.gif";
        $smiley[':razz:']           = "sm_bigrazz.gif";
        $smiley[':roll:']           = "sm_rolleyes.gif";
        $smiley[':eek:']            = "sm_bigeek.gif";
        $smiley[':no:']             = "sm_no.gif";
        $smiley[':cry:']            = "sm_cry.gif";
    }

    //Define replace tags
    $replace1  = array("[url]","[/url]","[email]","[/email]");
    $replace21 = array("[b]","[i]","[u]");
    $replace22 = array("[/b]","[/i]","[/u]");
    $replace2  = array_merge($replace21, $replace22);
    $replace3  = array("<b>","<i>","<u>","</b>","</i>","</u>");

    //replace url and emailtags because we do not show them in our modules
    foreach($replace1 as $replace) {
      $text = str_replace($replace,"",$text);
    }

    //if text has to be in a range we abridge him
    if($length>0) {
      $add = "";

      //replace simple html-tags with bb_code
      for($i=0;$i<count($replace3);$i++) {
        $text = str_replace($replace3[$i],$replace2[$i],$text);
      }

      //replace smilies with shorttags or remove them
      if($this->_config['smiliesupport']==1) {
        $count=0; $smileshort = array();
        foreach ( $smiley as $i=>$sm ) {
          $text = str_replace ($i, "{".$count."}", $text);
          $smileshort[$count]["short"] = $i;
          $smileshort[$count]["long"]  = $sm;
          $count++;
        }
      } else {
        foreach ( $smiley as $i=>$sm ) {
            $text = str_replace ($i, "", $text);
        }
      }

     //remove any html because it is to complicated to handle them
     $text = strip_tags($text);

      //some testfragment checks if tags could be sliced
      $testtext = substr($text,$length-2,$length+2);
      $change = 0;
      foreach($replace2 as $replace) {
        if(strpos($testtext,$replace,0)!=false) {
          $change = -2+strpos($testtext,$replace,0);
        }
      }
      for($i=0;$i<count($smileshort);$i++) {
        if(strpos($testtext,"{".$i."}",0)!=false) {
          $change = -2+strpos($testtext,"{".$i."}",0);
        }
      }

      //define new textlength because of tags
      $strcount = $length+$change;

      //Adding mising tags at the end of the text
      if ( $this->_config['bbcodesupport']==1 && strlen($text)>$strcount) {
        $testtext = substr($text,$strcount,strlen($text)-1);
        for($i=0;$i<count($replace21);$i++) {
          if( (    strpos($testtext,$replace21[$i],$strcount)===false
                && strpos($testtext,$replace22[$i],$strcount)>0
                && strpos($testtext,$replace22[$i],$strcount)!=false )
           || (    strpos($testtext,$replace21[$i],$strcount)>strpos($testtext,$replace22[$i],$strcount)
                && strpos($testtext,$replace22[$i],$strcount)!=false ) ) {
            $add .= $replace22[$i];
          }
        }
      }
      //abridge text and add missing tags
      $text = substr($text,0,$strcount);
      if($this->_config['showcmtmore']==0) {
       $text .= "...";
      }
    }

    //decoding bb_code or remove tags
    if ( $this->_config['bbcodesupport']==1 ) {
      //including common.ponygallery.php for decoding bb_code function
      if(!function_exists('bb_decode')) {
        include(_PONY_ABSOLUTE_PATH.'/administrator/components/com_ponygallery/common.ponygallery.php');
      }
      $text=bb_decode( $text );
    } else {
      foreach($replace2 as $replace) {
        $text = str_replace($replace,"",$text);
      }
    }


    //decoding smilies or remove them
    if ( $this->_config['smiliesupport']==1 && $length<1) {
      foreach ( $smiley as $i=>$sm ) {
        $text = str_replace ($i, "<img src=\"".$mosConfig_live_site."/components/com_ponygallery/images/smilies/".$this->_config['smiliescolor']."/".$sm."\" border=\"0\" alt=\"".$i."\" title=\"".$i."\" />", $text);
      }
    } elseif($this->_config['smiliesupport']==1 && $length>0) {
       for($i=0;$i<count($smileshort);$i++) {
        $text = str_replace ("{".$i."}", "<img src=\"".$mosConfig_live_site."/components/com_ponygallery/images/smilies/".$this->_config['smiliescolor']."/".$smileshort[$i]['long']."\" border=\"0\" alt=\"".$smileshort[$i]['short']."\" title=\"".$smileshort[$i]['short']."\" />", $text);
      }
    } else {
      foreach ( $smiley as $i=>$sm ) {
        $text = str_replace ($i, "", $text);
      }
    }
    return $text;
  }
}
?>
